@if exp="typeof(global.zoom_object) == 'undefined'"
@iscript

/*
	wi/Oi摜̊gkʂɂ\svOC
*/

class ZoomPlugin extends KAGPlugin
{
	var tempLayer; // e|C
	var overlayLayer; // I[o[CC

	var sl, st, sw, sh;
	var dl, dt, dw, dh;
	var startTick; // JneBbN
	var time; // Y[sĂ鎞
	var mode; // OiC[h
	var accel; // xIȓs (  : 0 :  )
	var storage;
	var moving = false;
	var nextstop;
	var moveFunc; // ړʒuvZp֐
	var targetLayerName; // ΏۃC
	var targetLayer; // ΏۃC

	function ZoomPlugin(window)
	{
		super.KAGPlugin();
		this.window = window;
	}

	function finalize()
	{
		// finalize \bh
		// ̃NX̊Ǘ邷ׂẴIuWFNg𖾎Iɔj
		stop();

		invalidate tempLayer if tempLayer !== void;
		invalidate overlayLayer if overlayLayer !== void;

		super.finalize(...);
	}

	function startZoom(storage, layer, mode, basestorage, sl, st, sw, sh, dl, dt, dw, dh, time, accel)
	{
		// storage : \摜
		// layer : ΏۃC
		// mode : OiC̓߃[h
		// bgimage : wi摜
		// sl st sw sh : ʒu
		// dl dt dw dh : ŏIʒu
		// time : Y[sĂ鎞
		// accel : 邩ǂ

		// ̓~
		stop();

		// ΏۃC
		if(layer == '' || layer == 'base')
			targetLayer = window.fore.base;
		else
			targetLayer = window.fore.layers[+layer];

		// wi摜̓ǂݍ
		if(basestorage !== void)
			window.tagHandlers.image(%[ storage : basestorage, layer : layer, page : 'fore']);

		// IuWFNgɃp[^Rs[
		this.sl = sl; this.st = st; this.sw = sw; this.sh = sh;
		this.dl = dl; this.dt = dt; this.dw = dw; this.dh = dh;
		this.time = time;
		this.accel = accel;
		this.storage = storage;
		this.targetLayerName = layer;
		this.mode = mode;

		// tempLayer m
		var base = window.fore.base;
		if(tempLayer === void)
		{
			tempLayer = new Layer(window, base);
			tempLayer.loadImages(storage);
		}

		// overlayLayer m
		if(overlayLayer === void)
		{
			overlayLayer = new Layer(window, base);
			overlayLayer.absolute = targetLayer.absolute + 1; // ΏۃĈO
			overlayLayer.hitType = htMask;
			overlayLayer.hitThreshold = 256; // }EXbZ[W͑S擧
			overlayLayer.face = dfBoth;
			overlayLayer.type = layer == 'base' ? ltCoverRect : (mode == 'rect' ? ltCoverRect : ltTransparent);
			// overlayLayer  TCY邢͍ŏITCŶǂ炩傫
			// ̃TCYɂȂ邪AʃTCY͑傫ȂȂ
			var mw = sw > dw ? sw : dw;
			var mh = sh > dh ? sh : dh;
			overlayLayer.setImageSize(
				mw < base.imageWidth ? mw : base.imageWidth,
				mh < base.imageHeight ? mh : base.imageHeight);
		}

		// ړʒuvZ֐̐ݒ
		moveFunc = defaultMover;

		// ʒuɕ\
		moveFunc(moveAt, 0);
		overlayLayer.visible = true;
		if(layer != 'base') targetLayer.visible = false;

		// Jn
		startTick = System.getTickCount();
		System.addContinuousHandler(continuousHandler);
		moving = true;
		nextstop = false;
	}

	function moveAt(l, t, w, h)
	{
		// l t w h ʒuɈړ

		// Cړ
		var base = window.fore.base;
		var oll = l < 0 ? 0 : l;
		var olt = t < 0 ? 0 : t;
		var olw = l + w > base.imageWidth ? base.imageWidth - oll : l + w - oll;
		var olh = t + h > base.imageHeight ? base.imageHeight - olt : t + h - olt;
		if(olw > 0 && olh > 0)
		{
			overlayLayer.visible = true;
			overlayLayer.setPos(oll, olt, olw, olh);

			// gk]
			overlayLayer.stretchCopy(l - oll, t - olt, w, h,
				tempLayer, 0, 0, tempLayer.imageWidth, tempLayer.imageHeight);
				// ړ悪E≺ɂ͂ݏoꍇɂƖʂȓ]N邩
		}
		else
		{
			overlayLayer.visible = false;
		}
	}

	/*static*/ function defaultMover(func, tm)
	{
		// ʒuvZ
		// tm  0.0(Jn_) ` 1.0(I_) ̊ԂŕωϐȂ̂ŁA
		// ɂĈʒuvZ
		var l = (int)((dl - sl) * tm + sl);
		var t = (int)((dt - st) * tm + st);
		var w = (int)((dw - sw) * tm + sw);
		var h = (int)((dh - sh) * tm + sh);

		// ړ
		func(l, t, w, h);
	}

	function continuousHandler(tick)
	{
		// nh
		if(nextstop)
		{
			// I
			finish();
			return;
		}

		// Ԃ𓾂
		var tm = tick - startTick;
		tm /= time;
		if(tm >= 1)
		{
			nextstop = true;
			tm = 1;
		}
		else
		{
			// vZ
			if(accel < 0)
			{
				// ㌷ ( ŏAXɒxȂ )
				tm = 1.0 - tm;
				tm = Math.pow(tm, -accel);
				tm = 1.0 - tm;
			}
			else if(accel > 0)
			{
				//  ( ŏ͓xAXɑȂ )
				tm = Math.pow(tm, accel);
			}
		}

		// ړ
		moveFunc(moveAt, tm);
	}

	function finish()
	{
		// Y[̏I
		if(targetLayerName == 'base')
		{
			// wiC̏ꍇ
			var base = window.fore.base;
			if(dl == 0 && dt == 0 && dw == base.imageWidth && dh == base.imageHeight &&
				tempLayer.imageWidth == base.imageWidth && tempLayer.imageHeight == base.imageHeight)
			{
				// ŏIʒuʑŜ𕢂ĂāAA
				// Y[摜̃TCYwi摜Ɠꍇ
				// 摜ǂݍ
				window.tagHandlers.image(%[ storage : storage, layer : 'base', page : 'fore']);
			}
			else
			{
				// ŏIʒuʑŜ𕢂ĂȂ;
				// ̏ꍇ́AŏIʒũTCY 0 łȂ
				// ̏Ԃ̞x̍ĊJ͕s\ ( wi摜č\łȂ )
				// ( wiɉ摜ǂݍ񂾂ƂȂ OK )
				window.fore.base.face = dfBoth;
				window.fore.base.stretchCopy(dl, dt, dw, dh, tempLayer, 0, 0,
					tempLayer.imageWidth, tempLayer.imageHeight);
			}
		}
		else
		{
			// OiC̏ꍇ
			if(dw == tempLayer.imageWidth && dh == tempLayer.imageHeight)
			{
				// ŏIʒũTCYOiCƓꍇ
				// 摜ǂݍ
				window.tagHandlers.image(%[ storage : storage, layer : targetLayerName, page : 'fore',
					left : dl, top : dt, visible : true, mode : mode]);
			}
			else
			{
				// łȂꍇ
				// ̏ꍇ́AŏIʒũTCY 0 ŖA
				// ̏Ԃx̍ĊJ͕s\
				// (Ώۂ̃Cɉ摜xǂݒȂΉ)
				if(dw && dh)
				{
					targetLayer.setImageSize(dw < 0 ? -dw : dw, dh < 0 ? -dh : dh);
					targetLayer.setSizeToImageSize();
					targetLayer.setPos(dl, dt);
					targetLayer.face = dfBoth;
					targetLayer.stretchCopy(dw < 0 ? dw : 0, dh < 0 ? dh : 0, dw, dh, tempLayer, 0, 0,
						tempLayer.imageWidth, tempLayer.imageHeight);
					targetLayer.visible = true;
					targetLayer.type = ltTransparent;
				}
				else
				{
					targetLayer.visible = false;
				}
			}
		}
		stop(); // ~
	}

	function stop()
	{
		// ~
		if(moving)
		{
			window.trigger('zoom');
			System.removeContinuousHandler(continuousHandler);
			moving = false;
		}
		invalidate tempLayer if tempLayer !== void;
		tempLayer = void;
		invalidate overlayLayer if overlayLayer !== void;
		overlayLayer = void;
		targetLayer = void;
	}

	function onStore(f, elm)
	{
		// xۑƂ
	}

	function onRestore(f, clear, elm)
	{
		// xǂݏoƂ
		stop(); // ~
	}

	function onStableStateChanged(stable)
	{
	}

	function onMessageHiddenStateChanged(hidden)
	{
	}

	function onCopyLayer(toback)
	{
	}

	function onExchangeForeBack()
	{
	}
}

kag.addPlugin(global.zoom_object = new ZoomPlugin(kag));
	// vOCIuWFNg쐬Ao^

@endscript
@endif
; }No^
@macro name="bgzoom"
@eval exp="zoom_object.startZoom(mp.storage, 'base', 'rect', mp.basestorage, +mp.sl, +mp.st, +mp.sw, +mp.sh, +mp.dl, +mp.dt, +mp.dw, +mp.dh, +mp.time, +mp.accel)"
@endmacro
@macro name="wbgzoom"
@if exp="zoom_object.moving"
@waittrig * name="zoom" onskip="zoom_object.finish()"
@endif
@endmacro
@macro name="fgzoom"
@eval exp="zoom_object.startZoom(mp.storage, mp.layer, mp.mode, void, +mp.sl, +mp.st, +mp.sw, +mp.sh, +mp.dl, +mp.dt, +mp.dw, +mp.dh, +mp.time, +mp.accel)"
@endmacro
@macro name="wfgzoom"
@if exp="zoom_object.moving"
@waittrig * name="zoom" onskip="zoom_object.finish()"
@endif
@endmacro
@return
